



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>koa简介</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">koa简介</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 03:31:15 </span>
						</div>
										<div class="post-content">
											
		<p>资料来源:<br /><a href="http://javascript.ruanyifeng.com/nodejs/koa.html" rel="external nofollow noreferrer">http://javascript.ruanyifeng.com/nodejs/koa.html</a><br /><a href="http://koa.bootcss.com/" rel="external nofollow noreferrer">http://koa.bootcss.com/</a></p>
<p>以下内容为摘抄，纯属做笔记加深印象。勿喷。</p>
<p>使用 koa 编写 web 应用，通过组合不同的 generator，可以免除重复繁琐的回调函数嵌套，并极大地提升错误处理的效率。一个Koa应用就是一个对象，包含了一个middleware数组，这个数组由一组Generator函数组成。这些函数负责对HTTP请求进行各种加工，比如生成缓存、指定代理、请求重定向等等。这些中间件函数基于 request 请求以一个类似于栈的结构组成并依次执行。</p>
<p>Koa 包含了像 content-negotiation（内容协商）、cache freshness（缓存刷新）、proxy support（代理支持）和 redirection（重定向）等常用任务方法。 与提供庞大的函数支持不同，Koa只包含很小的一部分，因为Koa并不绑定任何中间件。</p>
<h4><strong>中间件</strong></h4>
<p>Koa的中间件很像Express的中间件，也是对HTTP请求进行处理的函数，但是必须是一个Generator函数。而且，Koa的中间件是一个级联式（Cascading）的结构，也就是说，属于是层层调用，第一个中间件调用第二个中间件，第二个调用第三个，以此类推。上游的中间件必须等到下游的中间件返回结果，才会继续执行，这点很像递归。</p>
<p>中间件通过当前应用的use方法注册。</p>
<div>
<pre class="prettyprint linenums">app.use(function* (next){<br />
  var start = new Date; // （1）<br />
  yield next;  // （2）<br />
  var ms = new Date - start; // （3）<br />
  console.log('%s %s - %s', this.method, this.url, ms); // （4）<br />
});</pre>
</div>
<p>Generator函数内部使用yield命令，将程序的执行权转交给下一个中间件，即<code>yield next</code>，要等到下一个中间件返回结果，才会继续往下执行。只要有一个中间件缺少<code>yield next</code>语句，后面的中间件都不会执行，这一点要引起注意。</p>
<p>如果想跳过一个中间件，可以直接在该中间件的第一行语句写上<code>return yield next</code>。</p>
<div>
<pre class="prettyprint linenums">app.use(function* (next) {<br />
  if (skip) return yield next;<br />
})</pre>
</div>
<p>由于Koa要求中间件唯一的参数就是next，导致如果要传入其他参数，必须另外写一个返回Generator函数的函数。</p>
<div>
<pre class="prettyprint linenums">function logger(format) {<br />
  return function *(next){<br />
    var str = format<br />
      .replace(':method', this.method)<br />
      .replace(':url', this.url);

    console.log(str);

    yield next;<br />
  }<br />
}

app.use(logger(':method :url'));</pre>
</div>
<p><strong>路由</strong></p>
<p>可以通过<code>this.path</code>属性，判断用户请求的路径，从而起到路由作用。</p>
<div>
<pre class="prettyprint linenums">app.use(function* (next) {<br />
  if (this.path === '/') {<br />
    this.body = 'we are at home!';<br />
  } else {<br />
    yield next;<br />
  }<br />
})</pre>
</div>
<p>复杂的路由需要安装koa-router插件。</p>
<div>
<pre class="prettyprint linenums">var app = require('koa')();<br />
var Router = require('koa-router');

var myRouter = new Router();

myRouter.get('/', function *(next) {   //<code>router.get</code>方法的第一个参数是根路径，第二个参数是对应的函数方法。<br />　　this.response.body = 'Hello World!';</pre>
<pre class="prettyprint linenums">});

app.use(myRouter.routes());

app.listen(3000);</pre>
</div>
<p>Koa-router实例提供一系列动词方法，即一种HTTP动词对应一种方法。典型的动词方法有以下五种。</p>
<ul><li>router.get()</li>
<li>router.post()</li>
<li>router.put()</li>
<li>router.del()</li>
<li>router.patch()</li></ul>
<p>这些动词方法可以接受两个参数，第一个是路径模式，第二个是对应的控制器方法（中间件），定义用户请求该路径时服务器行为。</p>
<div>Koa-router允许为路径统一添加前缀。</div>
<div>
<div>
<pre class="prettyprint linenums">var router = new Router({<br />
  prefix: '/users'<br />
});

router.get('/', ...); // 等同于"/users"<br />
router.get('/:id', ...); // 等同于"/users/:id"</pre>
</div>
</div>
<h4>app.listen(...)</h4>
<p>Koa 应用并非是一个 1-to-1 表征关系的 HTTP 服务器。 一个或多个Koa应用可以被挂载到一起组成一个包含单一 HTTP 服务器的大型应用群。</p>
<p>如下为一个绑定3000端口的简单 Koa 应用，其创建并返回了一个 HTTP 服务器。</p>
<div>
<pre class="prettyprint linenums">var koa = require('koa');<br />
var app = koa();<br />
app.listen(3000);</pre>
</div>
<h4>app.callback()</h4>
<p>返回一个适合 http.createServer() 方法的回调函数用来处理请求。 您也可以使用这个回调函数将您的app挂载在 Connect/Express 应用上。</p>
<h4>app.use(function)</h4>
<p>为应用添加指定的中间件,<a href="https://github.com/koajs/koa/wiki#middleware" rel="external nofollow noreferrer">https://github.com/koajs/koa/wiki#middleware</a>,也就是向middleware数组添加Generator函数。</p>
<h4>app.keys=</h4>
<p>设置签名Cookie密钥，该密钥会被传递给 KeyGrip。</p>
<p>自己生成秘钥实例:</p>
<div>
<pre class="prettyprint linenums">app.keys = ['im a newer secret', 'i like turtle'];<br />
app.keys = new KeyGrip(['im a newer secret', 'i like turtle'], 'sha256');</pre>
</div>
<h4>错误处理</h4>
<p>默认情况下Koa会将所有错误信息输出到 stderr，除非 NODE_ENV 是 "test"。为了实现自定义错误处理逻辑（比如 centralized logging），您可以添加 "error" 事件监听器。</p>
<div>
<pre class="prettyprint linenums">app.on('error', function(err, ctx){<br />
  log.error('server error', err, ctx);<br />
});</pre>
</div>
<h4>Context(上下文)</h4>
<p>Koa Context 将 node 的 request 和 response 对象封装在一个单独的对象里面，其为编写 web 应用和 API 提供了很多有用的方法。</p>
<p>context 在每个 request 请求中被创建，在中间件中作为接收器(receiver)来引用，或者通过 this 标识符来引用：</p>
<div>
<pre class="prettyprint linenums">app.use(function *(){<br />
  this; // is the Context<br />
  this.request; // is a koa Request<br />
  this.response; // is a koa Response<br />
});</pre>
</div>
<h2>CSRF攻击</h2>
<p>CSRF攻击是指用户的session被劫持，用来冒充用户的攻击。</p>
<p>koa-csrf插件用来防止CSRF攻击。原理是在session之中写入一个秘密的token，用户每次使用POST方法提交数据的时候，必须含有这个token，否则就会抛出错误。</p>
<h2>数据压缩</h2>
<p>koa-compress模块可以实现数据压缩。</p>
<div>
<pre class="prettyprint linenums">app.use(require('koa-compress')())<br />
app.use(function* () {<br />
  this.type = 'text/plain'<br />
  this.body = fs.createReadStream('filename.txt')<br />
})</pre>
</div>
<h4>API</h4>
<ul><li><p>ctx.req<br />Node 的 request 对象。</p></li>
<li><p>ctx.res<br />Node 的 response 对象。</p></li>
<li><p>ctx.request<br />Koa 的 Request 对象。</p></li>
<li><p>ctx.response<br />Koa 的 Response 对象。</p></li>
<li><p>ctx.app<br />应用实例引用。</p></li>
<li><p>ctx.cookies.get(name, [options])<br />获得 cookie 中名为 name 的值,options 为可选参数：</p>
<ul><li>'signed': 如果为 true，表示请求时 cookie 需要进行签名。</li></ul></li>
<li><p>ctx.cookies.set(name, value, [options])<br />设置 cookie 中名为 name 的值，options 为可选参数：</p>
<ul><li>signed: 是否要做签名</li>
<li>expires: cookie 有效期时间</li>
<li>path: cookie 的路径，默认为 /'</li>
<li>domain: cookie 的域</li>
<li>secure: false 表示 cookie 通过 HTTP 协议发送，true 表示 cookie 通过 HTTPS 发送。</li>
<li>httpOnly: true 表示 cookie 只能通过 HTTP 协议发送</li></ul></li>
<li><p>ctx.throw(msg, [status])<br />抛出包含 .status 属性的错误，默认为 500。该方法可以让 Koa 准确的响应处理状态。</p></li></ul>
<h4>请求(Request)API</h4>
<p>Koa Request 对象是对 node 的 request 进一步抽象和封装，提供了日常 HTTP 服务器开发中一些有用的功能。</p>
<ul><li><p>req.header<br />请求头对象</p></li>
<li><p>req.method<br />请求方法</p></li>
<li><p>req.method=<br />设置请求方法，在实现中间件时非常有用，比如 methodOverride()。</p></li>
<li><p>req.length<br />以数字的形式返回 request 的内容长度(Content-Length)，或者返回 undefined。</p></li>
<li><p>req.url<br />获得请求url地址。</p></li>
<li><p>req.url=<br />设置请求地址，用于重写url地址时。</p></li>
<li><p>req.originalUrl<br />获取请求原始地址。</p></li>
<li><p>req.path<br />获取请求路径名。</p></li>
<li><p>req.path=<br />设置请求路径名，并保留请求参数(就是url中?后面的部分)。</p></li>
<li><p>req.querystring<br />获取查询参数字符串(url中?后面的部分)，不包含 ?。</p></li>
<li><p>req.querystring=<br />设置查询参数。</p></li>
<li><p>req.search<br />获取查询参数字符串，包含 ?。</p></li>
<li><p>req.search=<br />设置查询参数字符串。</p></li>
<li><p>req.host</p></li>
<li><p>req.hostname</p></li>
<li><p>req.charset</p></li>
<li><p>req.query<br />将查询参数字符串进行解析并以对象的形式返回，如果没有查询参数字字符串则返回一个空对象。</p></li>
<li><p>req.query=<br />根据给定的对象设置查询参数字符串。</p></li>
<li><p>req.fresh<br />检查请求缓存是否 "fresh"(内容没有发生变化)。该方法用于在 If-None-Match / ETag, If-Modified-Since 和 Last-Modified 中进行缓存协调。当在 response headers 中设置一个或多个上述参数后，该方法应该被使用。</p></li></ul>
<div>
<pre class="prettyprint linenums">this.set('ETag', '123');

// cache is ok<br />
if (this.fresh) {<br />
  this.status = 304;<br />
  return;<br />
}

// cache is stale<br />
// fetch new data<br />
this.body = yield db.find('something');  </pre>
</div>
<ul><li><p>req.stale<br />与 req.fresh 相反。</p></li>
<li><p>req.protocol<br />返回请求协议，"https" 或者 "http"。 当 app.proxy 设置为 true 时，支持 X-Forwarded-Host。</p></li>
<li><p>req.secure<br />简化版 this.protocol == "https"，用来检查请求是否通过 TLS 发送。</p></li>
<li><p>req.ip<br />请求远程地址。 当 app.proxy 设置为 true 时，支持 X-Forwarded-Host。</p></li>
<li><p>req.is(type)<br />检查请求所包含的 "Content-Type" 是否为给定的 type 值。 如果没有 request body，返回 undefined。 如果没有 content type，或者匹配失败，返回 false。 否则返回匹配的 content-type。</p></li></ul>
<div>
<pre class="prettyprint linenums">// With Content-Type: text/html; charset=utf-8<br />
this.is('html'); // =&gt; 'html'<br />
this.is('text/html'); // =&gt; 'text/html'<br />
this.is('text/*', 'text/html'); // =&gt; 'text/html'

// When Content-Type is application/json<br />
this.is('json', 'urlencoded'); // =&gt; 'json'<br />
this.is('application/json'); // =&gt; 'application/json'<br />
this.is('html', 'application/*'); // =&gt; 'application/json'

this.is('html'); // =&gt; false</pre>
</div>
<ul><li><p>req.accepts(types)<br />检查给定的类型 types(s) 是否可被接受，当为 true 时返回最佳匹配，否则返回 false。type 的值可以是一个或者多个 mime 类型字符串。</p></li>
<li><p>req.acceptsEncodings(encodings)<br />检查 encodings 是否可以被接受，当为 true 时返回最佳匹配，否则返回 false。 注意：您应该在 encodings 中包含 identity。</p></li></ul>
<div>
<pre class="prettyprint linenums">// Accept-Encoding: gzip<br />
this.acceptsEncodings('gzip', 'deflate', 'identity');<br />
// =&gt; "gzip"

this.acceptsEncodings(['gzip', 'deflate', 'identity']);<br />
// =&gt; "gzip"</pre>
</div>
<ul><li>req.acceptsCharsets(charsets)<br />检查 charsets 是否可以被接受，如果为 true 则返回最佳匹配， 否则返回 false。</li></ul>
<div>
<pre class="prettyprint linenums">// Accept-Charset: utf-8, iso-8859-1;q=0.2, utf-7;q=0.5<br />
this.acceptsCharsets('utf-8', 'utf-7');<br />
// =&gt; "utf-8"

this.acceptsCharsets(['utf-7', 'utf-8']);<br />
// =&gt; "utf-8"</pre>
</div>
<ul><li><p>req.socket<br />返回请求的socket。</p></li>
<li><p>req.get(field)<br />返回请求 header 中对应 field 的值。</p></li></ul>
<h4>响应(Response)API</h4>
<p>Koa Response 对象是对 node 的 response 进一步抽象和封装，提供了日常 HTTP 服务器开发中一些有用的功能。</p>
<ul><li><p>res.header<br />Response header 对象。</p></li>
<li><p>res.socket<br />Response socket。</p></li>
<li><p>res.status<br />获取 response status。不同于 node 在默认情况下 res.statusCode 为200，res.status 并没有赋值。</p></li>
<li><p>res.statusString<br />Response status 字符串。</p></li>
<li><p>res.status=<br />通过数字状态码或者不区分大小写的字符串来设置response status.</p></li>
<li><p>res.length=<br />通过给定值设置 response Content-Length。</p></li>
<li><p>res.length<br />如果 Content-Length 作为数值存在，或者可以通过 res.body 来进行计算，则返回相应数值，否则返回 undefined。</p></li>
<li><p>res.body<br />获得 response body。</p></li>
<li><p>res.body=</p></li>
<li><p>res.get(field)<br />获取 response header 中字段值，field 不区分大小写。</p></li></ul>
<div>
<pre class="prettyprint linenums">var etag = this.get('ETag');</pre>
</div>
<ul><li>res.set(field, value)<br />设置 response header 字段 field 的值为 value。</li></ul>
<div>
<pre class="prettyprint linenums">this.set('Cache-Control', 'no-cache');</pre>
</div>
<ul><li>res.set(fields)<br />使用对象同时设置 response header 中多个字段的值。</li></ul>
<div>
<pre class="prettyprint linenums">this.set({<br />
  'Etag': '1234',<br />
  'Last-Modified': date<br />
});</pre>
</div>
<ul><ul><li><p>res.remove(field)<br />移除 response header 中字段 filed。</p></li>
<li><p>res.type<br />获取 response Content-Type，不包含像 "charset" 这样的参数。</p></li>
<li><p>res.type=<br />通过 mime 类型的字符串或者文件扩展名设置 response Content-Type.</p></li>
<li><p>res.redirect(url, [alt])<br />执行 [302] 重定向到对应 url。</p></li>
<li><p>res.lastModified<br />如果存在 Last-Modified，则以 Date 的形式返回。</p></li>
<li><p>res.lastModified=<br />以 UTC 格式设置 Last-Modified。您可以使用 Date 或 date 字符串来进行设置。</p></li>
<li><p>res.append(field, val)<br />在 header 的 field 后面 追加 val。</p></li>
<li><p>res.vary(field)<br />相当于执行res.append('Vary', field)。</p></li></ul></ul>
<p><!--<br />
p.p1 {margin: 0.0px 0.0px 0.0px 0.0px; font: 12.0px 'PingFang SC Semibold'; color: #454545}<br />
span.s1 {font: 12.0px 'PingFang SC'}<br />
--></p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96owdy9.html">Redis五种数据结构简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1rogz8.html">MongoDB的查询操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pwzoy8.html">js设置、获取单值cookie和多值cookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdoe1v8.html">IOS7 edgesForExtendedLayout</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0e3elq.html">大数据工具&mdash;&mdash;Splunk</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjm05y9.html">win7防火墙开启ping</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1kjyk8.html">第二篇：gradle脚本运行环境分析（gradle的语义模型）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e16dkz9.html">bzoj 3110&colon; &lbrack;Zjoi2013&rsqb;K大数查询 树状数组套线段树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd7pggq.html">PHPCMS V9 如何启用伪静态</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv15z31q.html">Arcengine 开发，FeatureClass新增feature时&OpenCurlyDoubleQuote;The Geometry has no z-value&rdquo;或&amp;quot&semi;The Geometry has null z-value&amp;quot&semi;的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/90myrko8.html">WebAssembly：随风潜入夜</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kxrzz9.html">bzoj2006 NOI2010 数据结构&plus;堆维护区间和最大</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j4pyx8.html">DirectX11 With Windows SDK--26 计算着色器：入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me1gd0q.html">1&period;2 Why need pluggable&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj1d0r9.html">学习笔记TF058&colon;人脸识别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rlkg68.html">记录下这几天使用 GitHub 碰到的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyl6rx9.html">CSS图片两端对齐，自适应列表布局末行对齐修复实例页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvzmoj8.html">Locust性能测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25l6kxq.html">Java 注释规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2g12x9.html">课程一&lpar;Neural Networks and Deep Learning&rpar;总结&mdash;&mdash;1、Logistic Regression</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/rql1mnk9.html">新建 ASP&period;NET Core Web API 项目 -- RESTFul 风格 Hello World&excl;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx2drd8.html">IIS10中使用OpenSSL来创建CA并且签发SSL证书</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rn5r4q.html">NodeJS（node&period;exe&comma; npm&comma; express&comma; live-server）安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7ee5x9.html">Android开发学习&mdash;&mdash;应用安装过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqved219.html">&lbrack;转&rsqb;利用JitPack发布自己项目让别人可以在dependencies中compile的简单方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9ppm479.html">【代码笔记】iOS-水波效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/m963mvy9.html">【Swift 2&period;1】为 UIView 添加点击事件和点击效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7envk9.html">&lbrack;Erlang 0105&rsqb; Erlang Resources 小站 2013年1月~6月资讯合集</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnn53kq.html">&dollar;是对string&period;Format的简化</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4pk7jq.html">SQL SERVER 2012链接到SQL SERVER 2000的问题解决案例</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
